import java.util.ArrayList;
import java.util.Collections; // Collections.reverseOrder
import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.NoSuchElementException;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeMap;
import java.util.zip.*;

public class WebLinks {

	// feel free to use this or add other private static fields
	private static HashMap<String,LinkData> hashmap = new HashMap();

	// feel free to use this or write your own
	private static class LinkData {
		int numLinksFromMeToMe;
		int numLinksFromNotMeToMe;
		int numLinksFromMeToMyHome;
		int numLinksFromNotMeToMyHome;
		// no ctor.. implicit is initialize to 0's
	}

    public static Scanner loadFromFile(String name) {
        Scanner sc = null;
        try {
        	sc = new Scanner(new File(name));
		} catch (IOException e) {
			System.out.println("Couldn't find file?");
			return null;
		}
		return sc;
	}

    public static Scanner loadFromZipFile(String name) {
		ZipFile zf;
        try {
		    zf = new ZipFile(name);
		} catch (IOException e) {
			System.out.println("Couldn't find/open file?");
			return null;
		}
        ZipEntry ze = (ZipEntry)zf.entries().nextElement();
        Scanner sc = null;
        try {
        	sc = new Scanner(zf.getInputStream(ze));
		} catch (IOException e) {
			System.out.println("Couldn't create Scanner on ZipEntry?");
			return null;
		}
		return sc;
	}

	// if a URL contains http://www.cs.washington.edu/homes/FOOBAR/stuff...
	// then it returns FOOBAR, null otherwise
	// if homeDir is true, then it returns FOOBAR only if stuff... is empty
	// or index.*.  if homeDir is false, then stuff... can be anything.
	public static String getName(String url, boolean homeDir) {
		final String HOME = ".edu/homes/";
		if (url.contains(HOME)) {
			if (!homeDir) {
				int idx = url.indexOf(HOME)+HOME.length();
				String sub = url.substring(idx);
				int idx2 = sub.indexOf("/");
				if (idx2 == -1) return null;
				return sub.substring(0,idx2);
			}
			int idx = url.lastIndexOf("/");
			String substr = url.substring(0,idx);
			int idx2 = substr.lastIndexOf("/");
			String end = url.substring(idx);
//					System.out.println(substr+"***"+end);
			if (substr.substring(0,idx2).endsWith("homes") && (end.equals("/") || end.startsWith("index."))) {
				return url.substring(idx2+1,idx);
			} else return null;
		} else return null;
	}

	public static List topRankedMeToMe(int n) {
		throw new UnsupportedOperationException();
	}

	public static List topRankedMeToMyHome(int n) {
		throw new UnsupportedOperationException();
	}

	public static List topRankedNotMeToMe(int n) {
		throw new UnsupportedOperationException();
	}

	public static List topRankedNotMeToMyHome(int n) {
		throw new UnsupportedOperationException();
	}

    public static int numLinksFromMeToMe(String name) {
		throw new UnsupportedOperationException();
	}

    public static int numLinksFromNotMeToMe(String name) {
		throw new UnsupportedOperationException();
	}

    public static int numLinksFromMeToMyHome(String name) {
		throw new UnsupportedOperationException();
	}

    public static int numLinksFromNotMeToMyHome(String name) {
		throw new UnsupportedOperationException();
	}

	// do your precomputation in here
	public static void processLinks(Scanner sc) {
		int n=0;
		while(sc.hasNextLine()) {
			String line = sc.nextLine();
			int i = line.indexOf(" *from* ");
			if (i==-1) System.out.println("bad input, line "+n);
			else {
				String toURL = line.substring(0,i);
				String fromURL = line.substring(i+" *from* ".length());
				// FINISHME
				// FINISHME
				// FINISHME
			}
			n++;
			if (n%1000==0) System.out.println("processed "+n+" lines so far.");
		}
		System.out.println("read "+n+" lines.");
	}

	public static void main(String[] args) {
//		Scanner sc = loadFromFile("links-faketiny.txt"); // fake data for testing
		Scanner sc = loadFromZipFile("links.txt.zip"); // all 600000+ links
		processLinks(sc);

		System.out.println(numLinksFromMeToMe("gyngve")); // tiny: 3 all: 317
		System.out.println(numLinksFromNotMeToMe("gyngve")); // tiny: 2 all: 24
		System.out.println(numLinksFromMeToMyHome("gyngve")); // tiny: 2 all: 7
		System.out.println(numLinksFromNotMeToMyHome("gyngve")); // tiny: 1 all: 17
		System.out.println();
		System.out.println(numLinksFromMeToMe("ncthach")); // tiny: 2 all: 6
		System.out.println(numLinksFromNotMeToMe("ncthach")); // tiny: 2 all: 2
		System.out.println(numLinksFromMeToMyHome("ncthach")); // tiny: 0 all: 6
		System.out.println(numLinksFromNotMeToMyHome("ncthach")); // tiny: 1 all: 2
		System.out.println();
		System.out.println(numLinksFromMeToMe("liudd")); // tiny: 1 all: 0
		System.out.println(numLinksFromNotMeToMe("liudd")); // tiny: 4 all: 0
		System.out.println(numLinksFromMeToMyHome("liudd")); // tiny: 1 all: 0
		System.out.println(numLinksFromNotMeToMyHome("liudd")); // tiny: 2 all: 0
		System.out.println();
		System.out.println(numLinksFromNotMeToMe("reges")); // tiny: 0 all: 155
		System.out.println(numLinksFromNotMeToMe("notkin")); // tiny: 0 all: 123
		System.out.println();

		// these only print for the full links zipfile
		for(Iterator i=topRankedMeToMe(10).iterator();i.hasNext();) {
			System.out.println(i.next());
		}
		System.out.println();
		// prints out: weld 6203, kautz 3258, jcarlson 2664, lazowska 1212, mnoy 994, wchan 846, lunadong 661, suciu 497, ning 490, chartung 460

		for(Iterator i=topRankedMeToMyHome(3).iterator();i.hasNext();) {
			System.out.println(i.next());
		}
		System.out.println();
		// prints out: suciu 384, kautz 362, weld 167

		for(Iterator i=topRankedNotMeToMe(5).iterator();i.hasNext();) {
			System.out.println(i.next());
		}
		System.out.println();
		// prints out: alon 730, lazowska 365, zives 251, salesin 211, curless 209

		for(Iterator i=topRankedNotMeToMyHome(5).iterator();i.hasNext();) {
			System.out.println(i.next());
		}
		// prints out: alon 703, zives 246, salesin 210, curless 207, ruzzo 173
	}
}
